searchData={"items":[{"type":"module","title":"Gluttony","doc":"Parses RSS 2.0 and Atom 1.0 feeds.\n\n# References\n- RSS 2.0 Specs: https://www.rssboard.org/rss-specification\n- Atom 1.0 Specs: https://xml2rfc.tools.ietf.org/public/rfc/html/rfc4287.html","ref":"Gluttony.html"},{"type":"module","title":"Extra information - Gluttony","doc":"- W3C Feed Docs: https://validator.w3.org/feed/docs/\n- RSS 2.0 and Atom 1.0 compared: http://www.intertwingly.net/wiki/pie/Rss20AndAtom10Compared","ref":"Gluttony.html#module-extra-information"},{"type":"function","title":"Gluttony.fetch_feed/2","doc":"Fetches the given url and parses the response.\nSee `parse_string/2` for more information on the result values.","ref":"Gluttony.html#fetch_feed/2"},{"type":"function","title":"Gluttony.parse_stream/2","doc":"Parses a stream of input and returns the values.\n\n# Examples\n\n  Parsing an XML stream from an RSS feed:\n\n    stream = File.stream!(\"rss_feed.xml\", :line, [encoding: :utf8])\n    {:ok, %{feed: feed, entries: entries}} = Gluttony.parse_stream(stream)","ref":"Gluttony.html#parse_stream/2"},{"type":"function","title":"Gluttony.parse_string/2","doc":"Parses the given string and returns the values.\n\n# Examples\n\n  Parsing a xml string from a RSS feed:\n\n    {:ok, %{feed: feed, entries: entries}} = Gluttony.parse_string(xml)\n\n  When a error happens, the reason is returned:\n\n    {:error, reason} = Gluttony.parse_string(xml)\n\n  You can retrieve a common result interface by specifing the `raw` option as `false`.\n  This might be usefull to retrieve only relevant and common information, since RSS 2.0 and Atom 1.0 are very different specs:\n\n    {:ok, %Gluttony.Feed{}} = Gluttony.parse_string(xml, raw: false)","ref":"Gluttony.html#parse_string/2"},{"type":"module","title":"Gluttony.Accessor.EmptyValue","doc":"Struct returned when a key does not exist in the feed or entry.","ref":"Gluttony.Accessor.EmptyValue.html"},{"type":"type","title":"Gluttony.Accessor.EmptyValue.t/0","doc":"","ref":"Gluttony.Accessor.EmptyValue.html#t:t/0"},{"type":"module","title":"Gluttony.Accessor.Unparsed","doc":"Struct returned when a value cannot be parsed.","ref":"Gluttony.Accessor.Unparsed.html"},{"type":"type","title":"Gluttony.Accessor.Unparsed.t/0","doc":"","ref":"Gluttony.Accessor.Unparsed.html#t:t/0"},{"type":"module","title":"Gluttony.Entry","doc":"Defines a common entry interface for RSS 2.0 and Atom 1.0 feeds.","ref":"Gluttony.Entry.html"},{"type":"type","title":"Gluttony.Entry.t/0","doc":"","ref":"Gluttony.Entry.html#t:t/0"},{"type":"module","title":"Gluttony.Feed","doc":"Defines a common channel interface for RSS 2.0 and Atom 1.0 feeds.","ref":"Gluttony.Feed.html"},{"type":"type","title":"Gluttony.Feed.t/0","doc":"","ref":"Gluttony.Feed.html#t:t/0"},{"type":"module","title":"Gluttony.Fetchers.Favicon","doc":"Retrieves icons available in the given URL.\nExposes the same functions as `HTTPoison`.","ref":"Gluttony.Fetchers.Favicon.html"},{"type":"function","title":"Gluttony.Fetchers.Favicon.delete/3","doc":"Issues a DELETE request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"Gluttony.Fetchers.Favicon.html#delete/3"},{"type":"function","title":"Gluttony.Fetchers.Favicon.delete!/3","doc":"Issues a DELETE request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"Gluttony.Fetchers.Favicon.html#delete!/3"},{"type":"function","title":"Gluttony.Fetchers.Favicon.get/3","doc":"Issues a GET request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"Gluttony.Fetchers.Favicon.html#get/3"},{"type":"function","title":"Gluttony.Fetchers.Favicon.get!/3","doc":"Issues a GET request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"Gluttony.Fetchers.Favicon.html#get!/3"},{"type":"function","title":"Gluttony.Fetchers.Favicon.head/3","doc":"Issues a HEAD request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"Gluttony.Fetchers.Favicon.html#head/3"},{"type":"function","title":"Gluttony.Fetchers.Favicon.head!/3","doc":"Issues a HEAD request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"Gluttony.Fetchers.Favicon.html#head!/3"},{"type":"function","title":"Gluttony.Fetchers.Favicon.options/3","doc":"Issues an OPTIONS request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"Gluttony.Fetchers.Favicon.html#options/3"},{"type":"function","title":"Gluttony.Fetchers.Favicon.options!/3","doc":"Issues a OPTIONS request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"Gluttony.Fetchers.Favicon.html#options!/3"},{"type":"function","title":"Gluttony.Fetchers.Favicon.patch/4","doc":"Issues a PATCH request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"Gluttony.Fetchers.Favicon.html#patch/4"},{"type":"function","title":"Gluttony.Fetchers.Favicon.patch!/4","doc":"Issues a PATCH request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"Gluttony.Fetchers.Favicon.html#patch!/4"},{"type":"function","title":"Gluttony.Fetchers.Favicon.post/4","doc":"Issues a POST request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"Gluttony.Fetchers.Favicon.html#post/4"},{"type":"function","title":"Gluttony.Fetchers.Favicon.post!/4","doc":"Issues a POST request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"Gluttony.Fetchers.Favicon.html#post!/4"},{"type":"function","title":"Gluttony.Fetchers.Favicon.process_headers/1","doc":"","ref":"Gluttony.Fetchers.Favicon.html#process_headers/1"},{"type":"function","title":"Gluttony.Fetchers.Favicon.process_request_body/1","doc":"","ref":"Gluttony.Fetchers.Favicon.html#process_request_body/1"},{"type":"function","title":"Gluttony.Fetchers.Favicon.process_request_headers/1","doc":"","ref":"Gluttony.Fetchers.Favicon.html#process_request_headers/1"},{"type":"function","title":"Gluttony.Fetchers.Favicon.process_request_options/1","doc":"","ref":"Gluttony.Fetchers.Favicon.html#process_request_options/1"},{"type":"function","title":"Gluttony.Fetchers.Favicon.process_request_params/1","doc":"","ref":"Gluttony.Fetchers.Favicon.html#process_request_params/1"},{"type":"function","title":"Gluttony.Fetchers.Favicon.process_request_url/1","doc":"","ref":"Gluttony.Fetchers.Favicon.html#process_request_url/1"},{"type":"function","title":"Gluttony.Fetchers.Favicon.process_response/1","doc":"","ref":"Gluttony.Fetchers.Favicon.html#process_response/1"},{"type":"function","title":"Gluttony.Fetchers.Favicon.process_response_body/1","doc":"","ref":"Gluttony.Fetchers.Favicon.html#process_response_body/1"},{"type":"function","title":"Gluttony.Fetchers.Favicon.process_response_chunk/1","doc":"","ref":"Gluttony.Fetchers.Favicon.html#process_response_chunk/1"},{"type":"function","title":"Gluttony.Fetchers.Favicon.process_response_headers/1","doc":"","ref":"Gluttony.Fetchers.Favicon.html#process_response_headers/1"},{"type":"function","title":"Gluttony.Fetchers.Favicon.process_response_status_code/1","doc":"","ref":"Gluttony.Fetchers.Favicon.html#process_response_status_code/1"},{"type":"function","title":"Gluttony.Fetchers.Favicon.process_status_code/1","doc":"","ref":"Gluttony.Fetchers.Favicon.html#process_status_code/1"},{"type":"function","title":"Gluttony.Fetchers.Favicon.process_url/1","doc":"","ref":"Gluttony.Fetchers.Favicon.html#process_url/1"},{"type":"function","title":"Gluttony.Fetchers.Favicon.put/4","doc":"Issues a PUT request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"Gluttony.Fetchers.Favicon.html#put/4"},{"type":"function","title":"Gluttony.Fetchers.Favicon.put!/4","doc":"Issues a PUT request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"Gluttony.Fetchers.Favicon.html#put!/4"},{"type":"function","title":"Gluttony.Fetchers.Favicon.request/1","doc":"Issues an HTTP request using an `HTTPoison.Request` struct.\n\nThis function returns `{:ok, response}`, `{:ok, async_response}`, or `{:ok, maybe_redirect}`\nif the request is successful, `{:error, reason}` otherwise.","ref":"Gluttony.Fetchers.Favicon.html#request/1"},{"type":"function","title":"Redirect handling - Gluttony.Fetchers.Favicon.request/1","doc":"If the option `:follow_redirect` is given, HTTP redirects are automatically follow if\nthe method is set to `:get` or `:head` and the response's `status_code` is `301`, `302` or\n`307`.\n\nIf the method is set to `:post`, then the only `status_code` that get's automatically\nfollowed is `303`.\n\nIf any other method or `status_code` is returned, then this function returns a\nreturns a `{:ok, %HTTPoison.MaybeRedirect{}}` containing the `redirect_url` for you to\nre-request with the method set to `:get`.","ref":"Gluttony.Fetchers.Favicon.html#request/1-redirect-handling"},{"type":"function","title":"Examples - Gluttony.Fetchers.Favicon.request/1","doc":"request = %HTTPoison.Request{\n      method: :post,\n      url: \"https://my.website.com\",\n      body: \"{\\\"foo\\\": 3}\",\n      headers: [{\"Accept\", \"application/json\"}]\n    }\n\n    request(request)","ref":"Gluttony.Fetchers.Favicon.html#request/1-examples"},{"type":"function","title":"Gluttony.Fetchers.Favicon.request/5","doc":"Issues an HTTP request with the given method to the given url.\n\nThis function is usually used indirectly by `get/3`, `post/4`, `put/4`, etc\n\nArgs:\n  * `method` - HTTP method as an atom (`:get`, `:head`, `:post`, `:put`,\n    `:delete`, etc.)\n  * `url` - target url as a binary string or char list\n  * `body` - request body. See more below\n  * `headers` - HTTP headers as an orddict (e.g., `[{\"Accept\", \"application/json\"}]`)\n  * `options` - Keyword list of options\n\nBody: see type `HTTPoison.Request`\n\nOptions: see type `HTTPoison.Request`\n\nThis function returns `{:ok, response}`, `{:ok, async_response}`, or `{:ok, maybe_redirect}`\nif the request is successful, `{:error, reason}` otherwise.","ref":"Gluttony.Fetchers.Favicon.html#request/5"},{"type":"function","title":"Redirect handling - Gluttony.Fetchers.Favicon.request/5","doc":"If the option `:follow_redirect` is given, HTTP redirects are automatically follow if\nthe method is set to `:get` or `:head` and the response's `status_code` is `301`, `302` or\n`307`.\n\nIf the method is set to `:post`, then the only `status_code` that get's automatically\nfollowed is `303`.\n\nIf any other method or `status_code` is returned, then this function returns a\nreturns a `{:ok, %HTTPoison.MaybeRedirect{}}` containing the `redirect_url` for you to\nre-request with the method set to `:get`.","ref":"Gluttony.Fetchers.Favicon.html#request/5-redirect-handling"},{"type":"function","title":"Examples - Gluttony.Fetchers.Favicon.request/5","doc":"request(:post, \"https://my.website.com\", \"{\\\"foo\\\": 3}\", [{\"Accept\", \"application/json\"}])","ref":"Gluttony.Fetchers.Favicon.html#request/5-examples"},{"type":"function","title":"Gluttony.Fetchers.Favicon.request!/1","doc":"Issues an HTTP request an `HTTPoison.Request` struct.\nexception in case of failure.\n\n`request!/1` works exactly like `request/1` but it returns just the\nresponse in case of a successful request, raising an exception in case the\nrequest fails.","ref":"Gluttony.Fetchers.Favicon.html#request!/1"},{"type":"function","title":"Gluttony.Fetchers.Favicon.request!/5","doc":"Issues an HTTP request with the given method to the given url, raising an\nexception in case of failure.\n\n`request!/5` works exactly like `request/5` but it returns just the\nresponse in case of a successful request, raising an exception in case the\nrequest fails.","ref":"Gluttony.Fetchers.Favicon.html#request!/5"},{"type":"function","title":"Gluttony.Fetchers.Favicon.start/0","doc":"Starts HTTPoison and its dependencies.","ref":"Gluttony.Fetchers.Favicon.html#start/0"},{"type":"function","title":"Gluttony.Fetchers.Favicon.stream_next/1","doc":"Requests the next message to be streamed for a given `HTTPoison.AsyncResponse`.\n\nSee `request!/5` for more detailed information.","ref":"Gluttony.Fetchers.Favicon.html#stream_next/1"},{"type":"type","title":"Gluttony.Fetchers.Favicon.body/0","doc":"","ref":"Gluttony.Fetchers.Favicon.html#t:body/0"},{"type":"type","title":"Gluttony.Fetchers.Favicon.headers/0","doc":"","ref":"Gluttony.Fetchers.Favicon.html#t:headers/0"},{"type":"type","title":"Gluttony.Fetchers.Favicon.method/0","doc":"","ref":"Gluttony.Fetchers.Favicon.html#t:method/0"},{"type":"type","title":"Gluttony.Fetchers.Favicon.options/0","doc":"","ref":"Gluttony.Fetchers.Favicon.html#t:options/0"},{"type":"type","title":"Gluttony.Fetchers.Favicon.params/0","doc":"","ref":"Gluttony.Fetchers.Favicon.html#t:params/0"},{"type":"type","title":"Gluttony.Fetchers.Favicon.request/0","doc":"","ref":"Gluttony.Fetchers.Favicon.html#t:request/0"},{"type":"type","title":"Gluttony.Fetchers.Favicon.url/0","doc":"","ref":"Gluttony.Fetchers.Favicon.html#t:url/0"},{"type":"module","title":"Gluttony.Fetchers.Opengraph","doc":"Retrieves opengraph information available in the given URL.\nExposes the same functions as `HTTPoison`.","ref":"Gluttony.Fetchers.Opengraph.html"},{"type":"function","title":"Gluttony.Fetchers.Opengraph.delete/3","doc":"Issues a DELETE request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"Gluttony.Fetchers.Opengraph.html#delete/3"},{"type":"function","title":"Gluttony.Fetchers.Opengraph.delete!/3","doc":"Issues a DELETE request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"Gluttony.Fetchers.Opengraph.html#delete!/3"},{"type":"function","title":"Gluttony.Fetchers.Opengraph.get/3","doc":"Issues a GET request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"Gluttony.Fetchers.Opengraph.html#get/3"},{"type":"function","title":"Gluttony.Fetchers.Opengraph.get!/3","doc":"Issues a GET request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"Gluttony.Fetchers.Opengraph.html#get!/3"},{"type":"function","title":"Gluttony.Fetchers.Opengraph.head/3","doc":"Issues a HEAD request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"Gluttony.Fetchers.Opengraph.html#head/3"},{"type":"function","title":"Gluttony.Fetchers.Opengraph.head!/3","doc":"Issues a HEAD request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"Gluttony.Fetchers.Opengraph.html#head!/3"},{"type":"function","title":"Gluttony.Fetchers.Opengraph.options/3","doc":"Issues an OPTIONS request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"Gluttony.Fetchers.Opengraph.html#options/3"},{"type":"function","title":"Gluttony.Fetchers.Opengraph.options!/3","doc":"Issues a OPTIONS request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"Gluttony.Fetchers.Opengraph.html#options!/3"},{"type":"function","title":"Gluttony.Fetchers.Opengraph.patch/4","doc":"Issues a PATCH request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"Gluttony.Fetchers.Opengraph.html#patch/4"},{"type":"function","title":"Gluttony.Fetchers.Opengraph.patch!/4","doc":"Issues a PATCH request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"Gluttony.Fetchers.Opengraph.html#patch!/4"},{"type":"function","title":"Gluttony.Fetchers.Opengraph.post/4","doc":"Issues a POST request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"Gluttony.Fetchers.Opengraph.html#post/4"},{"type":"function","title":"Gluttony.Fetchers.Opengraph.post!/4","doc":"Issues a POST request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"Gluttony.Fetchers.Opengraph.html#post!/4"},{"type":"function","title":"Gluttony.Fetchers.Opengraph.process_headers/1","doc":"","ref":"Gluttony.Fetchers.Opengraph.html#process_headers/1"},{"type":"function","title":"Gluttony.Fetchers.Opengraph.process_request_body/1","doc":"","ref":"Gluttony.Fetchers.Opengraph.html#process_request_body/1"},{"type":"function","title":"Gluttony.Fetchers.Opengraph.process_request_headers/1","doc":"","ref":"Gluttony.Fetchers.Opengraph.html#process_request_headers/1"},{"type":"function","title":"Gluttony.Fetchers.Opengraph.process_request_options/1","doc":"","ref":"Gluttony.Fetchers.Opengraph.html#process_request_options/1"},{"type":"function","title":"Gluttony.Fetchers.Opengraph.process_request_params/1","doc":"","ref":"Gluttony.Fetchers.Opengraph.html#process_request_params/1"},{"type":"function","title":"Gluttony.Fetchers.Opengraph.process_request_url/1","doc":"","ref":"Gluttony.Fetchers.Opengraph.html#process_request_url/1"},{"type":"function","title":"Gluttony.Fetchers.Opengraph.process_response/1","doc":"","ref":"Gluttony.Fetchers.Opengraph.html#process_response/1"},{"type":"function","title":"Gluttony.Fetchers.Opengraph.process_response_body/1","doc":"","ref":"Gluttony.Fetchers.Opengraph.html#process_response_body/1"},{"type":"function","title":"Gluttony.Fetchers.Opengraph.process_response_chunk/1","doc":"","ref":"Gluttony.Fetchers.Opengraph.html#process_response_chunk/1"},{"type":"function","title":"Gluttony.Fetchers.Opengraph.process_response_headers/1","doc":"","ref":"Gluttony.Fetchers.Opengraph.html#process_response_headers/1"},{"type":"function","title":"Gluttony.Fetchers.Opengraph.process_response_status_code/1","doc":"","ref":"Gluttony.Fetchers.Opengraph.html#process_response_status_code/1"},{"type":"function","title":"Gluttony.Fetchers.Opengraph.process_status_code/1","doc":"","ref":"Gluttony.Fetchers.Opengraph.html#process_status_code/1"},{"type":"function","title":"Gluttony.Fetchers.Opengraph.process_url/1","doc":"","ref":"Gluttony.Fetchers.Opengraph.html#process_url/1"},{"type":"function","title":"Gluttony.Fetchers.Opengraph.put/4","doc":"Issues a PUT request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"Gluttony.Fetchers.Opengraph.html#put/4"},{"type":"function","title":"Gluttony.Fetchers.Opengraph.put!/4","doc":"Issues a PUT request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"Gluttony.Fetchers.Opengraph.html#put!/4"},{"type":"function","title":"Gluttony.Fetchers.Opengraph.request/1","doc":"Issues an HTTP request using an `HTTPoison.Request` struct.\n\nThis function returns `{:ok, response}`, `{:ok, async_response}`, or `{:ok, maybe_redirect}`\nif the request is successful, `{:error, reason}` otherwise.","ref":"Gluttony.Fetchers.Opengraph.html#request/1"},{"type":"function","title":"Redirect handling - Gluttony.Fetchers.Opengraph.request/1","doc":"If the option `:follow_redirect` is given, HTTP redirects are automatically follow if\nthe method is set to `:get` or `:head` and the response's `status_code` is `301`, `302` or\n`307`.\n\nIf the method is set to `:post`, then the only `status_code` that get's automatically\nfollowed is `303`.\n\nIf any other method or `status_code` is returned, then this function returns a\nreturns a `{:ok, %HTTPoison.MaybeRedirect{}}` containing the `redirect_url` for you to\nre-request with the method set to `:get`.","ref":"Gluttony.Fetchers.Opengraph.html#request/1-redirect-handling"},{"type":"function","title":"Examples - Gluttony.Fetchers.Opengraph.request/1","doc":"request = %HTTPoison.Request{\n      method: :post,\n      url: \"https://my.website.com\",\n      body: \"{\\\"foo\\\": 3}\",\n      headers: [{\"Accept\", \"application/json\"}]\n    }\n\n    request(request)","ref":"Gluttony.Fetchers.Opengraph.html#request/1-examples"},{"type":"function","title":"Gluttony.Fetchers.Opengraph.request/5","doc":"Issues an HTTP request with the given method to the given url.\n\nThis function is usually used indirectly by `get/3`, `post/4`, `put/4`, etc\n\nArgs:\n  * `method` - HTTP method as an atom (`:get`, `:head`, `:post`, `:put`,\n    `:delete`, etc.)\n  * `url` - target url as a binary string or char list\n  * `body` - request body. See more below\n  * `headers` - HTTP headers as an orddict (e.g., `[{\"Accept\", \"application/json\"}]`)\n  * `options` - Keyword list of options\n\nBody: see type `HTTPoison.Request`\n\nOptions: see type `HTTPoison.Request`\n\nThis function returns `{:ok, response}`, `{:ok, async_response}`, or `{:ok, maybe_redirect}`\nif the request is successful, `{:error, reason}` otherwise.","ref":"Gluttony.Fetchers.Opengraph.html#request/5"},{"type":"function","title":"Redirect handling - Gluttony.Fetchers.Opengraph.request/5","doc":"If the option `:follow_redirect` is given, HTTP redirects are automatically follow if\nthe method is set to `:get` or `:head` and the response's `status_code` is `301`, `302` or\n`307`.\n\nIf the method is set to `:post`, then the only `status_code` that get's automatically\nfollowed is `303`.\n\nIf any other method or `status_code` is returned, then this function returns a\nreturns a `{:ok, %HTTPoison.MaybeRedirect{}}` containing the `redirect_url` for you to\nre-request with the method set to `:get`.","ref":"Gluttony.Fetchers.Opengraph.html#request/5-redirect-handling"},{"type":"function","title":"Examples - Gluttony.Fetchers.Opengraph.request/5","doc":"request(:post, \"https://my.website.com\", \"{\\\"foo\\\": 3}\", [{\"Accept\", \"application/json\"}])","ref":"Gluttony.Fetchers.Opengraph.html#request/5-examples"},{"type":"function","title":"Gluttony.Fetchers.Opengraph.request!/1","doc":"Issues an HTTP request an `HTTPoison.Request` struct.\nexception in case of failure.\n\n`request!/1` works exactly like `request/1` but it returns just the\nresponse in case of a successful request, raising an exception in case the\nrequest fails.","ref":"Gluttony.Fetchers.Opengraph.html#request!/1"},{"type":"function","title":"Gluttony.Fetchers.Opengraph.request!/5","doc":"Issues an HTTP request with the given method to the given url, raising an\nexception in case of failure.\n\n`request!/5` works exactly like `request/5` but it returns just the\nresponse in case of a successful request, raising an exception in case the\nrequest fails.","ref":"Gluttony.Fetchers.Opengraph.html#request!/5"},{"type":"function","title":"Gluttony.Fetchers.Opengraph.start/0","doc":"Starts HTTPoison and its dependencies.","ref":"Gluttony.Fetchers.Opengraph.html#start/0"},{"type":"function","title":"Gluttony.Fetchers.Opengraph.stream_next/1","doc":"Requests the next message to be streamed for a given `HTTPoison.AsyncResponse`.\n\nSee `request!/5` for more detailed information.","ref":"Gluttony.Fetchers.Opengraph.html#stream_next/1"},{"type":"type","title":"Gluttony.Fetchers.Opengraph.body/0","doc":"","ref":"Gluttony.Fetchers.Opengraph.html#t:body/0"},{"type":"type","title":"Gluttony.Fetchers.Opengraph.headers/0","doc":"","ref":"Gluttony.Fetchers.Opengraph.html#t:headers/0"},{"type":"type","title":"Gluttony.Fetchers.Opengraph.method/0","doc":"","ref":"Gluttony.Fetchers.Opengraph.html#t:method/0"},{"type":"type","title":"Gluttony.Fetchers.Opengraph.options/0","doc":"","ref":"Gluttony.Fetchers.Opengraph.html#t:options/0"},{"type":"type","title":"Gluttony.Fetchers.Opengraph.params/0","doc":"","ref":"Gluttony.Fetchers.Opengraph.html#t:params/0"},{"type":"type","title":"Gluttony.Fetchers.Opengraph.request/0","doc":"","ref":"Gluttony.Fetchers.Opengraph.html#t:request/0"},{"type":"type","title":"Gluttony.Fetchers.Opengraph.url/0","doc":"","ref":"Gluttony.Fetchers.Opengraph.html#t:url/0"},{"type":"behaviour","title":"Gluttony.Handler","doc":"This module defines the behaviour for handlers.\n\nBoth `handle_element/2`, `handle_content/2` and `handle_cached/2` should return on of the following result tuples:\n\n- `{:entry, chars_or_attrs}` - To indicate that a new entry should be created.\n- `{:entry, :key, value}` - To indicate that a entry should be updated with the given key and value.\n- `{:feed, :key, value}` - To indicate that the feed should be updated with the given key and value.\n- `{:cache, :key}` - To indicate that the given key should be cached.\n  Because successive calls with the same key will clean the previous value, this should only be called on `handle_element`.\n  This will guarantee that the cache will live through the tag lifecycle, instead of being cleaned on whenever new content is found.\n- `{:cache, :key, value}` - To indicate that the given key should be cached with the given value.\n- `{:cont, chars_or_attrs}` - To indicate that the current element should be ignored.\n\nIf the value is a list, it will be appended to the existing value. Otherwise, it will replace the current value.\nIts also possible to pass a list as the path to create a nested structure (all intermidiate values will be created).","ref":"Gluttony.Handler.html"},{"type":"callback","title":"Gluttony.Handler.handle_cached/2","doc":"This callback is called when and element is about to finish.","ref":"Gluttony.Handler.html#c:handle_cached/2"},{"type":"callback","title":"Gluttony.Handler.handle_content/2","doc":"This callback is called when a content of a element is encountered.","ref":"Gluttony.Handler.html#c:handle_content/2"},{"type":"callback","title":"Gluttony.Handler.handle_element/2","doc":"This callback is called when a start element is encountered.","ref":"Gluttony.Handler.html#c:handle_element/2"},{"type":"type","title":"Gluttony.Handler.attrs/0","doc":"","ref":"Gluttony.Handler.html#t:attrs/0"},{"type":"type","title":"Gluttony.Handler.chars/0","doc":"","ref":"Gluttony.Handler.html#t:chars/0"},{"type":"type","title":"Gluttony.Handler.path/0","doc":"","ref":"Gluttony.Handler.html#t:path/0"},{"type":"type","title":"Gluttony.Handler.result/0","doc":"","ref":"Gluttony.Handler.html#t:result/0"},{"type":"type","title":"Gluttony.Handler.stack/0","doc":"","ref":"Gluttony.Handler.html#t:stack/0"},{"type":"module","title":"Gluttony.Parser","doc":"Deals with XML processing.\n\n# Remarks\nIf CDATA is not getting pickedup, make sure the rss source\nwas not processed or formatted in any form. Since we are not using a separate event\nto treat CDATA, we need to make sure there's no newlines between tag and content.\nMore information about why this is necessary ca be found here: https://github.com/qcam/saxy/issues/98.","ref":"Gluttony.Parser.html"},{"type":"module","title":"Gluttony.Unfurler","doc":"Enriches feed data by unfurling available urls.\nUses `Gluttony.Fetchers.Favicon` and `Gluttony.Fetchers.Opengraph` internally.","ref":"Gluttony.Unfurler.html"},{"type":"function","title":"Gluttony.Unfurler.unfurl/1","doc":"Accepts a `Gluttony.Feed` or `Gluttony.Entry` struct and retrieves data from the url.\n\nFor `Feed`, it returns favicons and images available in the given URL.\nFor `Entry`, it returns available opengraph information on the page.","ref":"Gluttony.Unfurler.html#unfurl/1"},{"type":"extras","title":"Gluttony","doc":"# Gluttony\n\nCompliant elixir RSS 2.0 and Atom 1.0 parser.\nIngests and parses RSS feeds and returns raw data that can be enriched by unfurling URLs.","ref":"README.html"},{"type":"extras","title":"Installation - Gluttony","doc":"Add `gluttony` to the of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:gluttony, \"~> 0.2.0\"}\n  ]\nend\n```","ref":"README.html#installation"},{"type":"extras","title":"Documentation - Gluttony","doc":"Documentation can be found at  .","ref":"README.html#documentation"},{"type":"extras","title":"Benchmarks - Gluttony","doc":"Thanks to [`Saxy`](https://github.com/qcam/saxy), Gluttony is probably one of the fastest libraries to parse RSS feeds out there. That is, libraries that use pure Elixir of course (without low level NIFs). You can run the benchmark project or see previous results in the `/bench` folder.\n\n> ⚠️ Notice that I'm currently using WSL2 to run the benchmarks, so the results may actually be more optimistic without the virtualization layer. I'm also currently only yielding half of the available resources from my machine to the VM.\n\nThe data I'm using to run the benchmarks is similar to what [`fast_rss`](https://github.com/avencera/fast_rss) (another RSS feed library that uses Rust for speed) is also using, so take a look on their benchmarks for some intersting comparissons.","ref":"README.html#benchmarks"},{"type":"extras","title":"Metrics - Gluttony","doc":"In the worst cases, Gluttony was more memory efficient than the current slowest alternative by using `0.0246 GB` compared to [`feedraptor's`](https://github.com/merongivian/feedraptor) surprising `8.22 GB`. Not only this, but in some cases finishing parsing the whole RSS feed `424.26x` faster than the current worst alternative.","ref":"README.html#metrics"},{"type":"extras","title":"TODOs - Gluttony","doc":"- Better document available options\n- Add typespecs to the common result interface (`Feed` / `Entry`)","ref":"README.html#todos"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,50,46,49]}}